/* $Id: com.c,v 1.3 1993/08/22 04:53:48 nils Exp $ */
/* with many changes from Redone */
/* Dutchie Branch 2.0 */

#include "config.h"
#include "externs.h"

static char *get_com_title P((dbref)); /* 100% Redone */
static char *get_com_title (player)
    dbref player;
{
    static char buf[1024];
    strcpy(buf,":");
    if ((*atr_get(player,A_CTITLE)))
	sprintf(buf," %s:",atr_get(player,A_CTITLE));
    return buf;
}

extern int is_on_channel(player,chan)
/* chan can be either an alias or a chan name <Redone> */
     dbref player;
     char *chan;
{
  char *clist;
  char *clbegin;
  char *calias;
  int l=0; 
  static char buf[1025];

  sprintf(buf,"%s ",atr_get(player,A_CHANNEL));
  clbegin=clist=buf;
  while(*clist) {
    l=0;

    if ((calias=strchr(clist,' ')))
      *calias ='\0';

    if (strchr(clist,';')) { /* check for an alias */
      calias=strchr(clist,';');
      *calias ='\0';
      calias++;   
      l=strlen(calias)+1;
    }
    if ((!strcmp(clist,chan)) || (!strcmp(calias,chan))) {
       return (clist-clbegin);
    }
    clist+=strlen(clist)+1+l;
  }
  return -1;
}

extern int pure_is_on_channel(player,chan)
/* chan can be only a chan name <Redone> */
     dbref player;
     char *chan;
{
  char *clist;
  char *clbegin;
  char *calias;
  int l=0; 
  static char buf[1025];

  sprintf(buf,"%s ",atr_get(player,A_CHANNEL));
  clbegin=clist=buf;
  while(*clist) {
    l=0;

    if ((calias=strchr(clist,' ')))
      *calias ='\0';

    if (strchr(clist,';')) { /* check for an alias */
      calias=strchr(clist,';');
      *calias ='\0';
      calias++;   
      l=strlen(calias)+1;
    }
    if (!strcmp(clist,chan)) {
	/* only difference with is_on_channel() */
       return (clist-clbegin);
    }
    clist+=strlen(clist)+1+l;
  }
  return -1;
}

extern char *unparse_com_alias(player,chan) /* 100% Redone */
    dbref player;
    char *chan;
{
    static char buf[1024];
    char *clist;
    int i=0; /* the default channel */

    strcpy(buf,atr_get(player,A_CHANNEL));
    clist=buf;
    if ((*chan)) 
       i=is_on_channel(player,chan); 
 
    if (i>=0) {
       clist=buf+i;  
       if (strchr(clist,' '))
          *strchr(clist,' ')='\0';
       if (strchr(clist,';'))
          *strchr(clist,';')='\0';
    } else *clist='\0';
    
    return clist;    
}

extern void com_send (channel, message)
     char *channel;
     char *message;
{	
  struct descriptor_data *d;
 
  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0 &&
	   pure_is_on_channel(d->player, channel)>=0) {
      queue_string(d, message); 
      queue_string(d, "\n");
    }
}

void com_send2(sender, channel, message)
     dbref sender;
     char *channel;
     char *message;
{
  static char buf[1024];
  struct descriptor_data *d;
 
  strcpy(buf,unparse_com_alias(sender,channel));
  if (buf[0]=='\0') return;
 
  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0
	  && pure_is_on_channel(d->player, buf)>=0) {
      queue_string(d, tprintf("[%s] %s",buf,spname(sender))); 
      queue_string(d, message); 
      queue_string(d, "\n");
    }
}

static void com_who P((dbref, char *));
static void com_who (player, channel)
     dbref player;
     char *channel;
{
  static char buf[1024];
  struct descriptor_data *d;
  int h=0;
 
  strcpy(buf,unparse_com_alias(player,channel));
  if (buf[0]=='\0') strcpy(buf,channel); /* if yur not on it yurself */
  
  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0 &&
	 pure_is_on_channel(d->player, buf)>=0) {

          if (!could_doit(player,d->player,A_LHIDE)) {
                
              if (controls(player,d->player,POW_WHO)) {
                 if (controls(player,d->player,POW_EXAMINE)
                    || (db[d->player].flags & SEE_OK))
                 {
                  notify(player,
   	          tprintf("%s is on channel %s (HIDDEN)",
		  unparse_object(player,d->player), buf));
                 } else {
                  notify(player,
   	          tprintf("%s is on channel %s (HIDDEN)",
		  spname(d->player), buf));
                 }  
              } 
	      h++; 
          } else {
          if (controls(player,d->player,POW_EXAMINE)
             || (db[d->player].flags & SEE_OK))
          {
             notify(player,
   	     tprintf("%s is on channel %s.",
		unparse_object(player,d->player), buf));
           } else {
             notify(player,
   	     tprintf("%s is on channel %s.", spname(d->player), buf));
           }  
          } 
    }

   if (h == 0)
     notify(player, "*** There are no hidden players on this channel.");
   else if (h == 1)
     notify(player, "*** There is one hidden player on this channel.");
   else
     notify(player, tprintf("*** There are %d hidden players on this channel.",
            h));

   notify(player, tprintf("--- %s ---", buf));
}


void do_com(player, arg1, arg2)
     dbref player;
     char *arg1;
     char *arg2;
{
  static char buf[1024];

  if (!*arg1) { /* default channel */
    char *s;
    strcpy(buf,atr_get(player,A_CHANNEL));
    if ((s=strchr(buf,' ')))
      *s = '\0';
    if ((s=strchr(buf,';'))) /* ignore the alias */
      *s='\0';
    arg1 = buf; /* the first chan in the list */  
  } 
  if (!*arg1) {
    notify(player,"no channel.");
    return;
  }
  if (strchr(arg1,' ')) {
    notify(player,"you're spacey.");
    return;
  }
  if (strchr(arg1,';')) {
    notify(player,"A channel name can not have ';' in it.");
    return;
  }
  
  if (!string_compare(arg2,"who"))
    com_who(player,arg1);
  else {
    char buf[2048];
    char Marker[3];
    
    if (Typeof(player) != TYPE_PLAYER && !power(player,POW_SPOOF)) {
      notify(player,"non-players can not send +com messsages.");
      return;
    }
    
    sprintf(Marker,":");
    if (*arg2 == ':') {	Marker[0]='\0'; }
    else if (*arg2 == ';') { sprintf(Marker,"'s"); }
 
    sprintf (buf,
	     "%s %s",
	     ((Marker[0] == ':')?(get_com_title(player)):Marker),
	     ((*arg2 == ':')||(*arg2 == ';'))?(arg2+1):arg2);
    com_send2(player,arg1, buf);

    if (is_on_channel(player,arg1)<0)
      notify(player,"your +com has been sent! yay!");
  }
}

extern void do_ctitle(player,ctitle) /* 100% Redone */
     dbref player;
     char *ctitle;
{
    if(Typeof(player)!=TYPE_PLAYER) {
      notify(player,"Non-players can not set a com channel title.");
      return;
    }

    if (*ctitle =='\0') {
       atr_clr(player, A_CTITLE);
       notify(player,"Com channel title message removed.");
       return;
    }
  
    atr_add(player, A_CTITLE, tprintf("<%s>", ctitle));
    notify(player,
	 tprintf("Com channel title message set to: <%s>", 
         ctitle));  
}

void do_channel(player,arg1) /* Redone of course */
     dbref player;
     char *arg1;
{
  int i;
  ptype k;
  char chan[1024];
  char buf[1024];
  char buf2[1024];	
  char *calias;
  char *end;
  char *old_chan;

  if(*arg1 == '\0') {
    if(*atr_get(player,A_CHANNEL)) {
      strcpy( buf, atr_get(player,A_CHANNEL) );
      calias=buf;

      while ( ((calias=strchr(calias,' '))!=0) && (*(calias+1)!='\0') ) {
 	    *calias='\n';
	    calias++;
      }
      notify(player,"You are currently on the following channels:");
      notify(player,"---- Channel list ----");
      notify(player,buf);	
      notify(player,"--- <chan>;<alias> ---");
      notify(player,tprintf("Your default channel is: %s",
                            unparse_com_alias(player,"")));
    } else {
      notify(player,"You aren't currently on any channels. For a general chatting channel, turn to");
      notify(player,"channel 'public'");
    }
  } else if (*arg1 == '+') {

    arg1++;
    if(Typeof(player)!=TYPE_PLAYER) {
      notify(player,"As of yet, non-players cannot talk on channels.");
      return;
    }
    if (!db[player].pows) return;
    k= *db[player].pows;
    if(*arg1 == '*' &&
       !(k==CLASS_OFFICIAL ||
	 k==CLASS_DIR)) {
      notify(player,perm_denied());
      return;
    }
    if(*arg1 == '.' &&
       !(k==CLASS_DIR ||
	 k==CLASS_ADMIN ||
	 k==CLASS_BUILDER)) {
      notify(player,perm_denied());
      return;
    }
    if(*arg1 == '_' &&
       !(k==CLASS_DIR ||
	 k==CLASS_ADMIN ||
	 k==CLASS_BUILDER ||
	 k==CLASS_OFFICIAL ||
	 k==CLASS_GUIDE)) {
      notify(player,perm_denied());
      return;
    }

    if (strchr(arg1,' ')) {
    	notify(player,"You can not use spaces in a channel name");
	return;
    }    
    
    buf[0]='\0';
    strcpy(chan,arg1);
    if ((calias=strchr(chan,';'))) {
       *calias='\0';
       calias++;
       if (strchr(calias,';')) {
          notify(player,
             "You can not have more than one alias per channel name");
	  return;
       }
       strcpy(buf,calias);
    }    

    if (chan[0]=='\0') {
      notify(player,"what channel?");
      return;
    }

    i = is_on_channel(player,chan);
     
    if (buf[0]!='\0') { 
      if (is_on_channel(player,buf)>=0) {
         notify(player,"You are already using that com alias.");
         return;
      }   
    } else {
      notify(player,
        "You did not include a com alias: +ch +<channelname>;<alias>");
      return;
    }
    
    if (i>=0) { /* change alias */
       strcpy(buf2,tprintf("%s;%s",unparse_com_alias(player,chan),buf));
       strcpy(chan,buf2); 
       strcpy(buf,atr_get(player,A_CHANNEL));
       if (*buf) {
          old_chan=buf+i;
          end = strchr(buf+i,' ');
          if (!end)
             end=strchr(buf+i,'\0');
          else {
             *end='\0';
             end++;
          }
       } 

       strcpy (buf2, atr_get(player,A_CHANNEL));
       strcpy(buf2+i, end);
       if ((end=strchr(buf2,'\0')) && *--end==' ') *end='\0';

       if (buf2[0]=='\0') {
         atr_add (player, A_CHANNEL, arg1);
       } else {  
         if (i==0) {
            atr_add(player,A_CHANNEL,tprintf("%s %s",
  	            chan, buf2));
         } else {
            atr_add(player,A_CHANNEL,tprintf("%s %s",
  	            buf2, chan));
         }
       } 
       notify(player,tprintf("channel alias changed: %s",chan));
    } else { /* add new channel */
       if(!(*atr_get(player,A_CHANNEL))) 
         atr_add(player,A_CHANNEL,arg1);
       else
         atr_add(player,A_CHANNEL,tprintf("%s %s",
	   atr_get(player,A_CHANNEL), arg1));
    
       com_send(chan,tprintf("[%s] %s has joined this channel.",
	   chan, spname(player)));

       if (buf[0]!='\0') {
          notify(player,
             tprintf("%s added to your channel list with alias: %s",
		 chan,buf));    
       } else 
         notify(player,
             tprintf("%s added to your channel list with no alias", chan));
       notify(player,tprintf("Your default channel is: %s",
              unparse_com_alias(player,"")));
     } /* end if-else */
    } else { /* leave a channel */
    int i, Minus; 

    Minus=0; 
    if (*arg1 == '-') { Minus=1; arg1++; }
    
    if (strchr(arg1,' ') || !*arg1) {
      notify(player,"sigh. such sillyness. try a less spacey channel name.");
      return;
    }
    i = is_on_channel(player, arg1);
    if (i<0) {
      notify(player,"you aren't on that channel.");
      return;
    }
    strcpy(buf,atr_get(player,A_CHANNEL));
    if (*buf) {
       old_chan=buf+i;
       end = strchr(buf+i,' ');
       if (!end)
         end=strchr(buf+i,'\0');
       else {
        *end='\0';
         end++;
       }
    } 

    strcpy (buf2, atr_get(player,A_CHANNEL));
    strcpy(buf2+i, end);
    if ((end=strchr(buf2,'\0')) && *--end==' ') *end='\0';

    if (Minus==1) { 
      static char chan[1024];

      strcpy(chan,unparse_com_alias(player,arg1));
 
      notify(player,tprintf("%s has been deleted from your channel list.",
			  chan));
      sprintf(buf,
              "[%s] %s has left this channel.", chan, spname(player));
      com_send(chan,buf);
      atr_add (player, A_CHANNEL, buf2);
      if (buf2[0]=='\0') {
         notify(player,"You are currently on no com channel.");
      } else {  
         notify(player,tprintf("Your default channel is: %s",
            unparse_com_alias(player,"")));
      } 
    } else {
      if ((!*atr_get(player,A_CHANNEL)) || (*buf2=='\0'))
        atr_add(player,A_CHANNEL,old_chan); 
      else
        atr_add(player,A_CHANNEL,tprintf("%s %s",   
                old_chan, buf2)); 

      notify(player, tprintf("Your default channel is now: %s",
	    unparse_com_alias(player,arg1)));
    }
     
  }

/*
    notify(player,"Usage:");
    notify(player,"  +channel +<channel>    :adds a channel");
    notify(player,"  +channel -<channel>    :deletes a channel");
    notify(player,"  +channel <channel>     :change current channel");
    notify(player,"  +channel               :lists your channels.");
    notify(player,"For a general chatting channel, try channel 'public'.");
*/
}

